/******************************************************/
/* H8 Q-STEER Sample Program header.h                 */
/*                                                    */
/******************************************************/

typedef union {
	unsigned char BYTE;
	struct {
		unsigned char B7:1;
		unsigned char B6:1;
		unsigned char B5:1;
		unsigned char B4:1;
		unsigned char B3:1;
		unsigned char B2:1;
		unsigned char B1:1;
		unsigned char B0:1;
	} BIT;
} _IOREG;

typedef union {
	unsigned char BYTE;
	struct {
		unsigned char ADF:1;
		unsigned char ADIE:1;
		unsigned char ADST:1;
		unsigned char SCAN:1;
		unsigned char CKS:1;
		unsigned char CH:3;
	} BIT;
} _ADCSR;

// SCI
struct st_sci { /* struct SCI */
	union { /* SMR */
		unsigned char BYTE; /* Byte Access */
		struct { /* Bit Access */
			unsigned char CA :1; /* C/A */
			unsigned char CHR :1; /* CHR */
			unsigned char PE :1; /* PE */
			unsigned char OE :1; /* O/E */
			unsigned char STOP:1; /* STOP */
			unsigned char MP :1; /* MP */
			unsigned char CKS :2; /* CKS */
		} BIT; /* */
	} SMR; /* */
	unsigned char BRR; /* BRR */
	union { /* SCR */
		unsigned char BYTE; /* Byte Access */
		struct { /* Bit Access */
			unsigned char TIE :1; /* TIE */
			unsigned char RIE :1; /* RIE */
			unsigned char TE :1; /* TE */
			unsigned char RE :1; /* RE */
			unsigned char MPIE:1; /* MPIE */
			unsigned char TEIE:1; /* TEIE */
			unsigned char CKE :2; /* CKE */
		} BIT; /* */
	} SCR; /* */
	unsigned char TDR; /* TDR */
	union { /* SSR */
		unsigned char BYTE; /* Byte Access */
		struct { /* Bit Access */
			unsigned char TDRE:1; /* TDRE */
			unsigned char RDRF:1; /* RDRF */
			unsigned char ORER:1; /* ORER */
			unsigned char FER :1; /* FER */
			unsigned char PER :1; /* PER */
			unsigned char TEND:1; /* TEND */
			unsigned char MPB :1; /* MPB */
			unsigned char MPBT:1; /* MPBT */
		} BIT; /* */
	} SSR; /* */
	unsigned char RDR; /* RDR */
	union { /* SCMR */
		unsigned char BYTE; /* Byte Access */
		struct { /* Bit Access */
			unsigned char :4; /* */
			unsigned char SDIR:1; /* SDIR */
			unsigned char SINV:1; /* SINV */
			unsigned char :1; /* */
			unsigned char SMIF:1; /* SMIF */
		} BIT; /* */
	} SCMR; /* */
}; /* */

typedef union{
	unsigned short WORD;
	struct{
		unsigned char H:8;
		unsigned char L:2;
		unsigned char RESERVE:6;
	} BYTE;
} _ADDR;

#define ABWCR	(*(volatile _IOREG *)0xFEE020)
#define P4DDR	(*(volatile _IOREG *)0xFEE003)
#define ADCSR (*(volatile _ADCSR *)0xFFFFE8)

// SCI
#define SCI0 (*(volatile struct st_sci *)0xFFFFB0) /* SCI0 Address*/
#define SCI1 (*(volatile struct st_sci *)0xFFFFB8) /* SCI1 Address*/
#define SCI2 (*(volatile struct st_sci *)0xFFFFC0) /* SCI2 Address*/

// AD
#define ADDRA (*(volatile _ADDR *)0xFFFFE0)
#define ADDRB (*(volatile _ADDR *)0xFFFFE2)
#define ADDRC (*(volatile _ADDR *)0xFFFFE4)
#define ADDRD (*(volatile _ADDR *)0xFFFFE6)
