/******************************************************/
/* H8 Q-STEER Sample Program For UITRON               */
/*                       xZTfoCXhCo */
/*                                                    */
/******************************************************/

#include "dev_acceleration_sensor.h"

inline ER acceleration_sensor_init(void)
{
	UB ac_setting_value;
	
	//8bitoX[hɐݒ
	sil_wrb_mem((VP)AC_SENSOR_BUS, AC_SENSOR_BUS_INIT);
		//====================
		// ABWCR fee020h bus width control register
		//=====================
		// 1111 1111b 0xff
		// 1~~~ ~~~~  (ABW7)
		// ~1~~ ~~~~  (ABW6)
		// ~~1~ ~~~~  (ABW5)
		// ~~~1 ~~~~  (ABW4)
		// ~~~~ 1~~~  (ABW3)
		// ~~~~ ~1~~  (ABW2)
		// ~~~~ ~~1~  (ABW1)
		// ~~~~ ~~~1  (ABW0)
	
	//|[g4o͂ɐݒ
	sil_wrb_mem((VP)AC_SENSOR_PORT, AC_SENSOR_PORT_INIT);
	
	//ADϊ̐ݒ
	ac_setting_value = (UB)sil_reb_mem((VP)AC_SENSOR_SETTING);
	sil_wrb_mem((VP)AC_SENSOR_SETTING, (ac_setting_value & AC_SENSOR_SETTING_INIT_MASK));
		//====================
		// ADCSR ffffe8h A/D control and status register
		//=====================
		// 0000 0000b 0x0
		// 0~~~ ~~~~  (ADF) A/DϊItO
		// ~0~~ ~~~~  (ADIE)  A/DϊI荞݂̔Ȃ
		// ~~0~ ~~~~  (ADST)  A/Dϊ̒~
		// ~~~0 ~~~~  (SCAN)  XL[hɐݒ
		// ~~~~ 0~~~  (CKS) A/Dϊ 134 state
		// ~~~~ ~000  (CH)  A/Dϊ̓̓`lݒ
	
	return E_OK;
}

inline void acceleration_sensor_get_value(UH *x, UH *y, UH *z)
{
	UB ac_setting_value;
	UH ac_value;
	int i, j;
	
	for(i=0; i < 3; i++){
		
		//ADϊ~
		ac_setting_value = (UB)sil_reb_mem((VP)AC_SENSOR_SETTING);
		sil_wrb_mem((VP)AC_SENSOR_SETTING, (ac_setting_value & AC_SENSOR_STOP_MASK));
			//====================
			// ADCSR ffffe8h A/D control and status register
			//=====================
			// 0000 0000b 0x0
			// 0~~~ ~~~~  (ADF)
			// ~0~~ ~~~~  (ADIE)
			// ~~0~ ~~~~  (ADST)  A/Dϊ~
			// ~~~0 ~~~~  (SCAN)
			// ~~~~ 0~~~  (CKS)
			// ~~~~ ~000  (CH)
		
		//̓`lύX
		ac_setting_value = (UB)sil_reb_mem((VP)AC_SENSOR_SETTING);
		sil_wrb_mem((VP)AC_SENSOR_SETTING, ((ac_setting_value & AC_SENSOR_CH_MASK) | (i & 0x03)));
			//====================
			// ADCSR ffffe8h A/D control and status register
			//=====================
			// 0000 0***b
			// 0~~~ ~~~~  (ADF)
			// ~0~~ ~~~~  (ADIE)
			// ~~0~ ~~~~  (ADST)
			// ~~~0 ~~~~  (SCAN)
			// ~~~~ 0~~~  (CKS)
			// ~~~~ ~***  (CH)  ̓`lݒ
		
		//ADϊJn
		ac_setting_value = (UB)sil_reb_mem((VP)AC_SENSOR_SETTING);
		sil_wrb_mem((VP)AC_SENSOR_SETTING, (ac_setting_value | AC_SENSOR_START_MASK));
			//====================
			// ADCSR ffffe8h A/D control and status register
			//=====================
			// 0010 0***b
			// 0~~~ ~~~~  (ADF)
			// ~0~~ ~~~~  (ADIE)
			// ~~1~ ~~~~  (ADST)  A/DϊJn
			// ~~~0 ~~~~  (SCAN)
			// ~~~~ 0~~~  (CKS)
			// ~~~~ ~***  (CH)
		
		// f[^̎擾I܂őҋ@
		while(TRUE){
			ac_setting_value = (UB)sil_reb_mem((VP)AC_SENSOR_SETTING);
			if(ac_setting_value >= (UB)AC_SENSOR_FINISH){
				// ADFZbg
				sil_wrb_mem((VP)AC_SENSOR_SETTING, (ac_setting_value & 0x7F));
				break;
			}
		}
			//====================
			// ADCSR ffffe8h A/D control and status register
			//=====================
			// 0010 0***b
			// 1~~~ ~~~~  (ADF) A/DϊIɃZbg
			// ~0~~ ~~~~  (ADIE)
			// ~~0~ ~~~~  (ADST)  A/DϊIɃZbg
			// ~~~0 ~~~~  (SCAN)
			// ~~~~ 0~~~  (CKS)
			// ~~~~ ~***  (CH)
		
		// f[^̑
		if(i == 0) *x = (UH)(sil_reh_mem((VP)AC_SENSOR_DR_X) >> 6) & 0x03FF;
		if(i == 1) *y = (UH)(sil_reh_mem((VP)AC_SENSOR_DR_Y) >> 6) & 0x03FF;
		if(i == 2) *z = (UH)(sil_reh_mem((VP)AC_SENSOR_DR_Z) >> 6) & 0x03FF;
			//====================
			// ADDRn A/D data register
			//=====================
			// **** **** **xx xxxxb
			// **** **** **~~ ~~~~  (AD)    A/Dϊꂽf[^
			// ~~~~ ~~~~ ~~xx xxxx  (Reserved)
		
	}

}



