/******************************************************/
/* H8 Q-STEER Sample Program For UITRON               */
/*                                   VAhCo */
/*                                                    */
/******************************************************/

#include "dev_serial.h"

inline ER serial_init(void)
{
	UB serial_status_value;
	int i;
	
	//VARg[WX^̃NA
	sil_wrb_mem((VP)SCI_CONTROL, SCI_CONTROL_CLEAR);
		//====================
		// SCI1.SCR ffffbah serial control register
		//=====================
		// 0000 0000b 0x0
	
	//VA[hWX^̏
	sil_wrb_mem((VP)SCI_MODE, SCI_MODE_INIT);
		//====================
		// SCI1.SMR ffffb8h serial mode register
		//=====================
		// 0000  0000b  0x30
		// 0~~~ ~~~~  (C/~A)  asynchronous communication mode
		// ~0~~ ~~~~  (CHR) f[^8bitɐݒ
		// ~~0~ ~~~~  (PE)  additional parity disable
		// ~~~0 ~~~~  (O/~E)  use even number parity
		// ~~~~ 0~~~  (STOP)  stop bit length 1
		// ~~~~ ~0~~  (MP)  Multi-Processer disable
		// ~~~~ ~~00  (CKS) baudrate generator clock source 
	
	//{[[g̐ݒ
	sil_wrb_mem((VP)SCI_BAUDRATE, SCI_BAUDRATE_INIT);
		//====================
		// SCI1.BRR ffffb9h serial bit rate register
		//=====================
		// 4800bps
	
	//ҋ@
	for(i = 0 ; i < 1000 ; i++);
	
	//SCI1̑M
	sil_wrb_mem((VP)SCI_CONTROL, SCI_CONTROL_INIT);
		//====================
		// SCI1.SCR ffffbah serial control register
		//=====================
		// 0011 0000b 0x30
		// 0~~~ ~~~~  (TIE) TX-Interrupt disable
		// ~0~~ ~~~~  (RIE) RX-Interrupt and ER-Interrupt disable
		// ~~1~ ~~~~  (TE)  M
		// ~~~1 ~~~~  (RE)  M
		// ~~~~ 0~~~  (MPIE)  Multi-Processer-Interrupt disable
		// ~~~~ ~0~~  (TEIE)  Transmit-End-Interrupt disable
		// ~~~~ ~~00  (CKE) select clock source
	
	//SCI1̓Ԃ\
	serial_status_value = (UB)sil_reb_mem((VP)SCI_STATUS);
	sil_wrb_mem((VP)SCI_STATUS, (serial_status_value & SCI_STATUS_INIT_MASK));
		//====================
		// SCI1.SSR ffffbch serial status register
		//=====================
		// 1000 0000b 0x80  
		// 1~~~ ~~~~  (TDRE)  TDRɃf[^Cg\łƂON
		// ~0~~ ~~~~  (RDRF)
		// ~~0~ ~~~~  (ORER)
		// ~~~0 ~~~~  (FER/ERS)
		// ~~~~ 0~~~  (PER)
		// ~~~~ ~0~~  (TEND)
		// ~~~~ ~~0~  (MPB)
		// ~~~~ ~~~0  (MPBT)
	
	return E_OK;
}

inline ER serial_tx_char(char tx_char)
{
	UB serial_status_value;
	
	//Mf[^܂ŃEFCg
	while(TRUE){
		serial_status_value = (UB)sil_reb_mem((VP)SCI_STATUS);
		if((serial_status_value & SCI_WAIT_MASK) != 0) break;
	}
		//====================
		// SCI1.SSR ffffbch serial status register
		//=====================
		// 1000 0000b 0x80
		// 1~~~ ~~~~  (TDRE)  TDRɃf[^Cg\ɂȂƂZbg
		// ~0~~ ~~~~  (RDRF)  
		// ~~0~ ~~~~  (ORER)
		// ~~~0 ~~~~  (FER/ERS)
		// ~~~~ 0~~~  (PER)
		// ~~~~ ~0~~  (TEND)
		// ~~~~ ~~0~  (MPB)
		// ~~~~ ~~~0  (MPBT)
	
	// Mf[^1Zbg
	sil_wrb_mem((VP)SCI_TDR, (VB)tx_char);
		//====================
		// SCI1.TDR ffffbbh serial transmit data register
		//=====================
		// Mf[^i[
	
	//MtÕNA
	serial_status_value = (UB)sil_reb_mem((VP)SCI_STATUS);
	sil_wrb_mem((VP)SCI_STATUS, (serial_status_value & SCI_START_MASK));
		//====================
		// SCI1.SSR ffffbch serial status register
		//=====================
		// 0000 0000b 0x80
		// 0~~~ ~~~~  (TDRE)  ZbgƒʐMJn
		// ~0~~ ~~~~  (RDRF)  
		// ~~0~ ~~~~  (ORER)
		// ~~~0 ~~~~  (FER/ERS)
		// ~~~~ 0~~~  (PER)
		// ~~~~ ~0~~  (TEND)
		// ~~~~ ~~0~  (MPB)
		// ~~~~ ~~~0  (MPBT)
}

