#ifndef _H8_HEADER_H
#define _H8_HEADER_H


/***************** I/O|[g *************************/

// ʓII/OWX^̃rbgtB[h`
typedef union {
	unsigned char BYTE;
	struct {
		unsigned char P7:1;
		unsigned char P6:1;
		unsigned char P5:1;
		unsigned char P4:1;
		unsigned char P3:1;
		unsigned char P2:1;
		unsigned char P1:1;
		unsigned char P0:1;
	} BIT;
} _IOREG;

// |[g4f[^fBNVWX^
#define P4DDR (*(volatile _IOREG *)0xFEE003)

// oXRg[WX^
#define ABWCR (*(volatile _IOREG *)0xFEE020)

// |[g4f[^WX^
#define P4DR  (*(volatile _IOREG *)0xFFFFD3)


/***************** VA|[g **********************/

// VA|[ĝ߂̍\
typedef struct{ /* struct SCI */
	
	union {                    /* SMR */
		unsigned char BYTE;      /* Byte Access */
		struct {                 /* Bit Access */
			unsigned char CA :1;   /* C/A */
			unsigned char CHR :1;  /* CHR */
			unsigned char PE :1;   /* PE */
			unsigned char OE :1;   /* O/E */
			unsigned char STOP:1;  /* STOP */
			unsigned char MP :1;   /* MP */
			unsigned char CKS :2;  /* CKS */
		} BIT;
	} SMR;
	
	unsigned char BRR; /* BRR */
	
	union {                      /* SCR */
		unsigned char BYTE;        /* Byte Access */
		struct {                   /* Bit Access */
			unsigned char TIE :1;    /* TIE */
			unsigned char RIE :1;    /* RIE */
			unsigned char TE :1;     /* TE */
			unsigned char RE :1;     /* RE */
			unsigned char MPIE:1;    /* MPIE */
			unsigned char TEIE:1;    /* TEIE */
			unsigned char CKE :2;    /* CKE */
		} BIT;
	} SCR;
	
	unsigned char TDR; /* TDR */
	
	union {                    /* SSR */
		unsigned char BYTE;      /* Byte Access */
		struct {                 /* Bit Access */
			unsigned char TDRE:1;  /* TDRE */
			unsigned char RDRF:1;  /* RDRF */
			unsigned char ORER:1;  /* ORER */
			unsigned char FER :1;  /* FER */
			unsigned char PER :1;  /* PER */
			unsigned char TEND:1;  /* TEND */
			unsigned char MPB :1;  /* MPB */
			unsigned char MPBT:1;  /* MPBT */
		} BIT;
	} SSR;
	
	unsigned char RDR; /* RDR */
	
	union {                    /* SCMR */
		unsigned char BYTE;      /* Byte Access */
		struct {                 /* Bit Access */
			unsigned char :4;      /* */
			unsigned char SDIR:1;  /* SDIR */
			unsigned char SINV:1;  /* SINV */
			unsigned char :1;      /* */
			unsigned char SMIF:1;  /* SMIF */
		} BIT;
	} SCMR;
	
} _SCI;

// SCI
#define SCI0 (*(volatile _SCI *)0xFFFFB0) /* SCI0 Address*/
#define SCI1 (*(volatile _SCI *)0xFFFFB8) /* SCI1 Address*/
#define SCI2 (*(volatile _SCI *)0xFFFFC0) /* SCI2 Address*/

/*****************8rbg^C}[ *************************/

// 8rbg^C}[p
// ^C}[Rg[WX^(8TCR)
typedef union {
	unsigned char BYTE;
	struct {
		unsigned char CMIEB:1;
		unsigned char CMIEA:1;
		unsigned char OVIE:1;
		unsigned char CCLR:2;
		unsigned char CKS:3;
	} BIT;
} _8TCR;

// ^C}[Rg[/Xe[^XWX^(8TCSR)
typedef union {
	unsigned char BYTE;
	struct {
		unsigned char CMFB:1;
		unsigned char CMFA:1;
		unsigned char OVF:1;
		unsigned char ADTE_ICE:1;
		unsigned char OIS:2;
		unsigned char OS:2;
	} BIT;
} _8TCSR;

/////////////////////////////////////////
//8rbg^C}[̂߂̍\
/////////////////////////////////////////
typedef struct{
	
	union {
		unsigned char BYTE;
		struct {
			unsigned char CMIEB:1;
			unsigned char CMIEA:1;
			unsigned char OVIE:1;
			unsigned char CCLR:2;
			unsigned char CKS:3;
		} BIT;
	} T8TCR0;

	union {
		unsigned char BYTE;
		struct {
			unsigned char CMIEB:1;
			unsigned char CMIEA:1;
			unsigned char OVIE:1;
			unsigned char CCLR:2;
			unsigned char CKS:3;
		} BIT;
	} T8TCR1;
	
	union {
		unsigned char BYTE;
		struct {
			unsigned char CMFB:1;
			unsigned char CMFA:1;
			unsigned char OVF:1;
			unsigned char ADTE_ICE:1;
			unsigned char OIS:2;
			unsigned char OS:2;
		} BIT;
	}T8TCSR0;
	
	union {
		unsigned char BYTE;
		struct {
			unsigned char CMFB:1;
			unsigned char CMFA:1;
			unsigned char OVF:1;
			unsigned char ADTE_ICE:1;
			unsigned char OIS:2;
			unsigned char OS:2;
		} BIT;
	}T8TCSR1;

	union{
			unsigned short T8TCORA;
			struct{
				unsigned char T8TCORA0;
				unsigned char T8TCORA1;
			} BYTE;
	};

	union{
			unsigned short T8TCORB;
			struct{
				unsigned char T8TCORB0;
				unsigned char T8TCORB1;
			} BYTE;
	};

	union{
			unsigned short T8TCNT;
			struct{
				unsigned char T8TCNT0;
				unsigned char T8TCNT1;
			} BYTE;
	};

} _8BIT_TIMER;

#define T8 (*(volatile _8BIT_TIMER *)0xFFFF80)


/***************** A/Dϊ *************************/
// ADDR
typedef union{
	unsigned short WORD;
	struct{
   		unsigned char H:8;
   		unsigned char L:2;
   		unsigned char RESERVE:6;
	} BYTE;
} _ADDR;

// A/Dϊ̂߂̋p
typedef union {
	unsigned char BYTE;
	struct {
		unsigned char ADF:1;
		unsigned char ADIE:1;
		unsigned char ADST:1;
		unsigned char SCAN:1;
		unsigned char CKS:1;
		unsigned char CH:3;
	} BIT;
} _ADCSR;

// 
#define ADDRA (*(volatile _ADDR *)0xFFFFE0)
#define ADDRB (*(volatile _ADDR *)0xFFFFE2)
#define ADDRC (*(volatile _ADDR *)0xFFFFE4)
#define ADDRD (*(volatile _ADDR *)0xFFFFE6)
// A/Dϊ̐ݒ
#define ADCSR (*(volatile _ADCSR *)0xFFFFE8)


/***************** ̑ *************************/

// 20us EFCg֐
extern void wait20us(void);

// ~bpEFCg֐
void wait( unsigned int ms )
{
	unsigned int i=0;
	unsigned int j=0;
	
	for( i=0 ; i<ms; i++){
		for(j=0;j<50;j++){
			wait20us();
		}
	}
}

// CPU荞݋
#define E_INT()	asm volatile ("andc.b #0x7f,ccr")

// 荞݋/֎~/nop
#define _nop()	asm volatile ("nop" )

#define _cli()	asm volatile ("orc.b #0x80,ccr")

#endif
