#include <msp430x20x3.h>

unsigned char RX_data;
unsigned int  RX_bit_count; 

void main(void)
{
 WDTCTL = WDTPW + WDTHOLD; //(1)
 BCSCTL1 = CALBC1_1MHZ;    //(2)
 DCOCTL = CALDCO_1MHZ;
 TACTL = TASSEL_2 + MC_2;  //(3)

 P1SEL |= 0x02;                  //(4)
 P1DIR &= ~0x02;                 //(4)
 CCTL0 = SCS + CM1 + CCIE + CAP; //(5)

 RX_bit_count = 8;
 RX_data=0;
 _BIS_SR(LPM0_bits + GIE);
 while(1);
}

#pragma vector=TIMERA0_VECTOR
__interrupt void timerA_0(void)
{
 CCR0 += 208;            //(8)
 if(CCTL0 & CAP){        //(6)  キャプチャモード
  CCTL0 &= ~CAP;         //(7)
  CCR0 += 104;           //(9)
 }else{                  //(10) コンペアモード
  RX_data = RX_data >> 1;
  
  if(CCTL0 & SCCI){
   RX_data |= 0x80;
  }
 
  RX_bit_count--;

  if(RX_bit_count == 0){ //(11) 受信の終了処理
    CCTL0 &= ~CCIE;
    _BIC_SR_IRQ(LPM0_bits);
  }
 }
}
